package main

import (
	"os"

	"github.com/spf13/cobra"
	"src.lwithers.me.uk/go/rsa/cmd/ca"
	"src.lwithers.me.uk/go/rsa/cmd/csr"
	"src.lwithers.me.uk/go/rsa/cmd/derive"
	"src.lwithers.me.uk/go/rsa/cmd/inspect"
	"src.lwithers.me.uk/go/rsa/cmd/keygen"
)

func main() {
	root := &cobra.Command{
		Use:   "rsa",
		Short: "RSA key and certificate manipulation",
	}

	inspect.Register(root)
	keygen.Register(root)
	csr.Register(root)
	ca.Register(root)
	derive.Register(root)

	if err := root.Execute(); err != nil {
		// error will already have been displayed
		os.Exit(1)
	}
}
